---
title: Building up a basic demo with the PlayCanvas engine
slug: Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_PlayCanvas/engine
tags:
  - 3D
  - Animation
  - Beginner
  - Canvas
  - Games
  - PlayCanvas
  - Tutorial
  - WebGL
  - camera
  - engine
  - lighting
  - rendering
---
<div>{{GamesSidebar}}</div><p class="summary"><span class="seoSummary">Built for modern browsers, <strong>PlayCanvas</strong> is a fully-featured 3D game engine with resource loading, an entity and component system, advanced graphics manipulation, collision and physics engine (built with <a href="https://github.com/kripken/ammo.js/">ammo.js</a>), audio, and facilities to handle control inputs from various devices (including gamepads).</span></p>

<p>That's quite an impressive list of features — let's see some in action.</p>

<p><img alt="PlayCanvas engine repository on GitHub." src="https://mdn.mozillademos.org/files/12257/playcanvas-github.png" style="display: block; height: 380px; margin: 0px auto; width: 600px;"></p>

<p>We will try putting together a simple demo first — a cube rendered on the screen. If you have already worked through our <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_Three.js">Building up a basic demo with Three.js</a> article (or you are familiar with other 3D libraries) you'll notice that PlayCanvas works on similar concepts: camera, light and objects.</p>

<h2 id="Environment_setup">Environment setup</h2>

<p>To start developing with PlayCanvas, you don't need much. You should start off by:</p>

<ul>
 <li>Making sure you are using a modern browser with good <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> support, such as the latest Firefox or Chrome.</li>
 <li>Creating a directory to store your experiments in.</li>
 <li>Saving a copy of the <a href="http://code.playcanvas.com/playcanvas-latest.js">latest PlayCanvas engine</a> inside your directory.</li>
 <li>Opening the <a href="http://developer.playcanvas.com/en/user-manual/">PlayCanvas documentation</a> in a separate tab — it is useful to refer to.</li>
</ul>

<h2 id="HTML_structure">HTML structure</h2>

<p>Here's the HTML structure we will use.</p>

<pre class="brush: html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
    &lt;meta charset="utf-8"&gt;
    &lt;title&gt;MDN Games: PlayCanvas demo&lt;/title&gt;
    &lt;style&gt;
        body { margin: 0; padding: 0; }
        canvas { width: 100%; height: 100%; }
    &lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;script src="playcanvas-latest.js"&gt;&lt;/script&gt;
&lt;canvas id="application-canvas"&gt;&lt;/canvas&gt;
&lt;script&gt;
    var canvas = document.getElementById("application-canvas");
    /* all our JavaScript code goes here */
&lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>It contains some basic information like the document {{htmlelement("title")}}, and some CSS to set the width and height of the {{htmlelement("canvas")}} element that PlayCanvas will use to 100% so that it will fill the entire available viewport space. The first {{htmlelement("script")}} element includes the PlayCanvas library in the page; we will write our example code in the second one. There is one helper variable already included, which will store a reference to the {{htmlelement("canvas")}} element.</p>

<p>Before reading on, copy this code to a new text file and save it in your working directory as <code>index.html</code>.</p>

<h2 id="PlayCanvas_application">PlayCanvas application</h2>

<p>To begin developing our game we have to create the PlayCanvas application first (using the given {{htmlelement("canvas")}} element), and then start the update loop. Add the following code to the bottom of your second {{htmlelement("script")}} element:</p>

<pre class="brush: js">var app = new pc.Application(canvas);
app.start();
</pre>

<p>The <code>pc</code> global object contains all the PlayCanvas functions available in the engine.</p>

<p>Next, we'll set the Canvas to fill the window, and automatically change its resolution to be the same as the Canvas size. Again, add the following lines at the bottom of your script.</p>

<pre class="brush: js">app.setCanvasFillMode(pc.FILLMODE_FILL_WINDOW);
app.setCanvasResolution(pc.RESOLUTION_AUTO);
</pre>

<h2 id="Camera">Camera</h2>

<p>Now when the setup code is in place we need to think about implementing the standard scene components: camera, lights and objects. Let's start with the camera — add these lines to your code, below the previous ones.</p>

<pre class="brush: js">var camera = new pc.Entity();
camera.addComponent("camera", {
    clearColor: new pc.Color(0.8, 0.8, 0.8)
});

app.root.addChild(camera);
camera.setPosition(0, 0, 7);
</pre>

<p>The code above will create a new <code>Entity</code>.</p>

<div class="note">
<p><strong>Note</strong>: An Entity is any object used in the scene — it can be an object like a box, cylinder or cone, but it can also be a camera, light or sound source.</p>
</div>

<p>Then it adds a <code>camera</code> component to it with the light gray <code>clearColor</code> — the color will be visible as the background. Next, the <code>camera</code> object is added to the root of our application and positioned to be 7 units away from the center of the scene on the <code>z</code> axis. This allows us to make some space to visualize the objects that we will create later on.</p>

<div class="note">
<p><strong>Note</strong>: The distance values (e.g. for the camera z position) are unitless, and can basically be anything you deem suitable for your scene — milimeters, meters, feet, or miles — it's up to you.</p>
</div>

<p>Try saving the file and loading it in your browser. You should now see a gray window. Congratulations!</p>

<h2 id="Geometry">Geometry</h2>

<p>Now the scene is properly rendering we can start adding 3D shapes to it. To speed up development PlayCanvas provides a bunch of predefined primitives that you can use to create shapes instantly in a single line of code. There are cubes, spheres, cylinders and more complicated shapes available. Drawing everything for given shape is taken care of by the engine, so we can focus on the high level coding. Let's start by defining the geometry for a cube shape — add the following new code below your previous additions:</p>

<pre class="brush: js">var box = new pc.Entity();
box.addComponent("model", { type: "box" });
app.root.addChild(box);
box.rotate(10, 15, 0);
</pre>

<p>It will create an <code>Entity</code> with the <code>box</code> model component and add it to the root of the application, our scene. We also rotate the box a bit to show that it's actually a 3D cube and not a square.</p>

<p>The cube is visible, but it is completely. To make it look better we need to shine some light onto it.</p>

<h2 id="Lights">Lights</h2>

<p>The basic light types in PlayCanvas are directional and ambient. The first type is a directional light placed somewhere on the scene while the scond one reflects the light from the first type, so it looks more natural; this can be set globally. Again, add the new code below your previous additions.</p>

<pre class="brush: js">var light = new pc.Entity();
light.addComponent('light');
app.root.addChild(light);
light.rotate(45, 0, 0);
</pre>

<p>It will create a light <code>Entity</code> component and add it to the scene. We can rotate the light on the <code>x</code> axis to make it shine on more than one side of the cube. It's time to add the ambient light:</p>

<pre class="brush: js">app.scene.ambientLight = new pc.Color(0.2, 0.2, 0.2);
</pre>

<p>The code above assign a dark grey ambient light for the whole scene. The box look better now, but it could get some colors to look even better - for that we need to create material for it.</p>

<h2 id="Material">Material</h2>

<p>The basic PlayCanvas material is called <a href="http://developer.playcanvas.com/en/api/pc.PhongMaterial.html">PhongMaterial</a> — add the following lines below the previous code.</p>

<pre class="brush: js">var boxMaterial = new pc.PhongMaterial();
boxMaterial.diffuse.set(0, 0.58, 0.86);
boxMaterial.update();
box.model.model.meshInstances[0].material = boxMaterial;
</pre>

<p>By diffusing the light on the object we can give it it's own color —we'll choose a nice familiar blue.</p>

<div class="note">
<p><strong>Note</strong>: In PlayCanvas, the color channel values are provided as floats in the range <code>0-1</code>, instead of integers of <code>0-255</code> as you might be used to using on the Web.</p>
</div>

<p>After the material is created and its color is set, it has to be updated so our changes are going to be applied. Then all we need to do is set the <code>box</code>'s material to the newly created <code>boxMaterial</code>.</p>

<p>Congratulations, you've created your first object in a 3D environment using PlayCanvas! It was easier than you thought, right? Here's how it should look:</p>

<p><img alt="Blue cube on a gray background rendered with PlayCanvas." src="https://mdn.mozillademos.org/files/12247/cube-playcanvas.png" style="display: block; height: 430px; margin: 0px auto; width: 600px;"></p>

<p>And here's the code we have created so far:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/cqs6pg3x/","","350")}}</p>

<p>You can also <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/PlayCanvas/cube.html">check it out on GitHub</a>.</p>

<h2 id="More_shapes">More shapes</h2>

<p>Now we will add more shapes to the scene. Let's move the cube 2 units to the left to make space for some friends — add the following line just below the previous code:</p>

<pre class="brush: js">box.translate(-2, 0, 0);
</pre>

<p>Now let's add a new shape — how about a cylinder?</p>

<h3 id="Cylinder">Cylinder</h3>

<p>Add the following lines at the bottom of your JavaScript code:</p>

<pre class="brush: js">var cylinder = new pc.Entity();
cylinder.addComponent("model", { type: "cylinder" });
app.root.addChild(cylinder);
cylinder.rotate(15, 0, 0);
</pre>

<p>This looks very similar to the code we used for creating a cube, but instead of the <code>box</code> component we are adding a <code>cylinder</code>. It is also rotated around the <code>x</code> axis to show it's actually a 3D shape. To make the cylinder have a color, let's say yellow, we need to create the material for it, as before. Add the following lines:</p>

<pre class="brush: js">var cylinderMaterial = new pc.PhongMaterial();
cylinderMaterial.diffuse.set(1, 0.58, 0);
cylinderMaterial.update();
cylinder.model.model.meshInstances[0].material = cylinderMaterial;
</pre>

<h3 id="Cone">Cone</h3>

<p>Creating a cone and its material is done in almost exacly the same way as we did for the cylinder. Add the following code, again, at the bottom of your script:</p>

<pre class="brush: js">var cone = new pc.Entity();
cone.addComponent("model", { type: "cone" });
app.root.addChild(cone);
cone.translate(2, 0, 0);

var coneMaterial = new pc.PhongMaterial();
coneMaterial.diffuse.set(0.9, 0.9, 0.9);
coneMaterial.update();
cone.model.model.meshInstances[0].material = coneMaterial;
</pre>

<p>The code above will create a new <code>cone</code>, add it to the <code>app</code> and move it by 2 units to the right so it's not overlapping the cylinder. Then the material is created, given a gray color, and assigned to the cone <code>Entity</code>.</p>

<p>Here's how it should look right now:</p>

<p><img alt="Shapes: blue cube, yellow cylinder and gray cone on a light gray background rendered with PlayCanvas." src="https://mdn.mozillademos.org/files/12249/shapes-playcanvas.png" style="display: block; height: 220px; margin: 0px auto; width: 600px;"></p>

<p>This works, but it is a bit boring. In a game something is usually happening — we can see animations and such — so let's try to breathe a little life into those shapes by animating them.</p>

<h2 id="Animation">Animation</h2>

<p>We already used <code>translate</code> or <code>rotate</code> to adjust the position of the shapes; we could also change their positions directly with <code>setPosition</code>, or scale them. To show actual animation, we need to make changes to these values inside the rendering loop, so they are updated on every frame. There's a special <code>update</code> event that we can use for that — add the following code just below the previous additions:</p>

<pre class="brush: js">var timer = 0;
app.on("update", function (deltaTime) {
    timer += deltaTime;
    // code executed on every frame
});
</pre>

<p>The callback takes the <code>deltaTime</code> as the parameter, so we have the relative time that has passed since the previous invocation of this update. For time based animations we'll use a <code>timer</code> variable that will store the time that has passed since the start of the app by adding the <code>deltaTime</code> to it on every update.</p>

<h3 id="Rotation">Rotation</h3>

<p>Rotating is quite easy — all you need to do is to add a defined value to the given direction of rotation on each frame. Add this line of code inside the <code>app.on("update")</code> callback function, right after the addition of the <code>deltaTime</code> to the <code>timer</code> variable:</p>

<pre class="brush: js">box.rotate(deltaTime*10, deltaTime*20, deltaTime*30);
</pre>

<p>It will rotate the <code>box</code> by <code>deltaTime*10</code> on the <code>x</code> axis, <code>deltaTime*20</code> on the <code>y</code> axis and <code>deltaTime*30</code> on the <code>z</code> axis, on very frame — giving us a smooth animation.</p>

<h3 id="Scaling">Scaling</h3>

<p>We can also scale a given object — there's a function for that called <code>setLocalScale</code>. Add the following, again into the callback:</p>

<pre class="brush: js">cylinder.setLocalScale(1, Math.abs(Math.sin(timer)), 1);
</pre>

<p>Here we are using <code>Math.sin</code> to scale the cylinder in a cycle, bigger and smaller again. We're wrapping the <code>y</code> scale value in <code>Math.abs</code> to pass the absolute values (greater or equal to 0); <code>sin</code> varies between -1 and 0, and for negative values the cylinder scaling can render unexpectedly (in this case it looks black half the time.)</p>

<p>Now onto the movement part.</p>

<h3 id="Moving">Moving</h3>

<p>Beside rotation and scaling we can also move objects around the scene. Add the following code to achieve that.</p>

<pre class="brush: js">cone.setPosition(2, Math.sin(timer*2), 0);
</pre>

<p>This will move the <code>cone</code> up and down by applying the <code>sin</code> value to the <code>y</code> axis on each frame, with a little bit of adjustment to make it look cooler. Try changing the value to see how it affects the animation.</p>

<h2 id="Conclusion">Conclusion</h2>

<p>Here's the final code listing, along with a viewable live example:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/auvcLoc4/","","350")}}</p>

<p>You can also <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/PlayCanvas/shapes.html">see it on GitHub</a> and <a href="https://github.com/end3r/MDN-Games-3D/">fork the repository</a> if you want to play with it yourself locally. Now you know the basics of PlayCanvas engine; happy experimentation!</p>

<h2 id="Summary">Summary</h2>

<p>Now you can continue reading the <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_PlayCanvas/editor">PlayCanvas editor</a> article, go back to the <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_PlayCanvas">Building up a basic demo with PlayCanvas</a> page, or go back a level higher to the main <a href="/en-US/docs/Games/Techniques/3D_on_the_web">3D Games on the Web</a> page.</p>
